﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using System.Diagnostics;
using Telerik.WinControls;

namespace _974847_RadTreeViewQ32015Performance
{
    public partial class Form1 : Form
    {
        private Stopwatch sw;
        public Form1()
        {
            InitializeComponent();

            this.radTreeView1.LazyMode = true;
            this.radTreeView1.NodesNeeded += radTreeView1_NodesNeeded;

            this.radTreeView1.NodeExpandedChanging += radTreeView1_NodeExpandedChanging;
            this.radTreeView1.NodeExpandedChanged += radTreeView1_NodeExpandedChanged;
        }

        private void radTreeView1_NodeExpandedChanged(object sender, RadTreeViewEventArgs e)
        {
            this.sw.Stop();
            RadMessageBox.Show("100 000 nodes loaded: " + this.sw.Elapsed.ToString());
        }

        private void radTreeView1_NodeExpandedChanging(object sender, RadTreeViewCancelEventArgs e)
        {
            this.sw = new Stopwatch();
            this.sw.Start();
        }

        private void radTreeView1_NodesNeeded(object sender, Telerik.WinControls.UI.NodesNeededEventArgs e)
        {
            if (e.Parent == null)
            {
                RadTreeNode mcNode = new RadTreeNode("Parent " + 0);
                e.Nodes.Add(mcNode);
                return;
            }
            else
            {
                this.LoadOneLevelNodes(e.Parent.Level + 1, e.Nodes);
                return;
            }
        }

        private void LoadOneLevelNodes(int level, IList<Telerik.WinControls.UI.RadTreeNode> nodes)
        {
            for (int i = 0; i < 100000; i++)
            {
                RadTreeNode mcNode = new RadTreeNode("Parent " + level);
                nodes.Add(mcNode);
            }
        }
    }
}
